//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41F944090175.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41F944090175.cm

//## begin module%41F944090175.cp preserve=no
//## end module%41F944090175.cp

//## Module: MarginGrid%41F944090175; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/MarginGrid.h

#ifndef MARGINGRID_H
#define MARGINGRID_H 1

//## begin module%41F944090175.additionalIncludes preserve=no
//## end module%41F944090175.additionalIncludes

//## begin module%41F944090175.includes preserve=yes
//## end module%41F944090175.includes

// Histogram
#include <XSUtil/Numerics/Histogram.h>
// Grid
#include <XSFit/Fit/Grid.h>
// Chain
#include <XSFit/MCMC/Chain.h>

class ChainManager;

//## begin module%41F944090175.declarations preserve=no
//## end module%41F944090175.declarations

//## begin module%41F944090175.additionalDeclarations preserve=yes
//## end module%41F944090175.additionalDeclarations


//## begin MarginGrid%41F944FD021B.preface preserve=yes
//## end MarginGrid%41F944FD021B.preface

//## Class: MarginGrid%41F944FD021B
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class MarginGrid : public Grid  //## Inherits: <unnamed>%41F9450D0201
{
  //## begin MarginGrid%41F944FD021B.initialDeclarations preserve=yes
  //## end MarginGrid%41F944FD021B.initialDeclarations

  public:
    //## Class: MarginInfo%41EFC3DB0131
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct MarginInfo 
    {
        // Data Members for Class Attributes

          //## Attribute: minRanges%41EFC44A011A
          //## begin MarginGrid::MarginInfo::minRanges%41EFC44A011A.attr preserve=no  public: std::vector<Real> {U} 
          std::vector<Real> minRanges;
          //## end MarginGrid::MarginInfo::minRanges%41EFC44A011A.attr

          //## Attribute: maxRanges%41EFC6510165
          //## begin MarginGrid::MarginInfo::maxRanges%41EFC6510165.attr preserve=no  public: std::vector<Real> {U} 
          std::vector<Real> maxRanges;
          //## end MarginGrid::MarginInfo::maxRanges%41EFC6510165.attr

          //## Attribute: nSteps%41EFC66C0202
          //## begin MarginGrid::MarginInfo::nSteps%41EFC66C0202.attr preserve=no  public: IntegerArray {U} 
          IntegerArray nSteps;
          //## end MarginGrid::MarginInfo::nSteps%41EFC66C0202.attr

          //## Attribute: isLog%41EFC689031F
          //## begin MarginGrid::MarginInfo::isLog%41EFC689031F.attr preserve=no  public: BoolArray {U} 
          BoolArray isLog;
          //## end MarginGrid::MarginInfo::isLog%41EFC689031F.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## begin MarginGrid::ProbabilityHist%41EEC8DE013A.preface preserve=yes
    //## end MarginGrid::ProbabilityHist%41EEC8DE013A.preface

    //## Class: ProbabilityHist%41EEC8DE013A; Instantiated Class
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef Numerics::Histogram< Real , Numerics::MixedBinning  > ProbabilityHist;

    //## begin MarginGrid::ProbabilityHist%41EEC8DE013A.postscript preserve=yes
    //## end MarginGrid::ProbabilityHist%41EEC8DE013A.postscript

    //## Constructors (specified)
      //## Operation: MarginGrid%41FA77E901D7
      MarginGrid (ChainManager* chainManager);

    //## Destructor (generated)
      virtual ~MarginGrid();


    //## Other Operations (specified)
      //## Operation: doGrid%41F9474C0311
      virtual void doGrid ();

      //## Operation: report%41F947EC01C1
      virtual void report (bool title = false) const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::MCMC::<unnamed>%41FA774500FB
      //## Role: MarginGrid::marginInfo%41FA77460304
      const MarginInfo& marginInfo () const;

      //## Association: XSFit::MCMC::<unnamed>%4200F4F5035C
      //## Role: MarginGrid::paramIDs%4200F4F8038C
      const std::vector<Chain::ParamID>& paramIDs () const;

  public:
    // Additional Public Declarations
      //## begin MarginGrid%41F944FD021B.public preserve=yes
      //## end MarginGrid%41F944FD021B.public

  protected:
    // Additional Protected Declarations
      //## begin MarginGrid%41F944FD021B.protected preserve=yes
      //## end MarginGrid%41F944FD021B.protected

  private:
    //## Constructors (generated)
      MarginGrid(const MarginGrid &right);

    //## Assignment Operation (generated)
      MarginGrid & operator=(const MarginGrid &right);


    //## Other Operations (specified)
      //## Operation: doPoint%41F9476F026F
      virtual void doPoint ();

      //## Operation: setMarginInfo%41FA760100F3
      void setMarginInfo ();

      //## Operation: makePoint%41FA761701F4
      static void makePoint (const std::vector<size_t>& indices, std::vector<Real>& point);

      //## Operation: calcBinCenters%41FE6B4A010B
      void calcBinCenters ();

    // Additional Private Declarations
      //## begin MarginGrid%41F944FD021B.private preserve=yes
      //## end MarginGrid%41F944FD021B.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: isSimple%41FA77BA015E
      //## begin MarginGrid::isSimple%41FA77BA015E.attr preserve=no  private: bool {U} 
      bool m_isSimple;
      //## end MarginGrid::isSimple%41FA77BA015E.attr

    // Data Members for Associations

      //## Association: XSFit::MCMC::<unnamed>%41FA774500FB
      //## begin MarginGrid::marginInfo%41FA77460304.role preserve=no  public: MarginGrid::MarginInfo { -> 1VHgN}
      MarginInfo m_marginInfo;
      //## end MarginGrid::marginInfo%41FA77460304.role

      //## Association: XSFit::MCMC::<unnamed>%41FA791402B7
      //## Role: MarginGrid::chainManager%41FA7915038B
      //## begin MarginGrid::chainManager%41FA7915038B.role preserve=no  private: ChainManager {1 -> 1RFHN}
      ChainManager* m_chainManager;
      //## end MarginGrid::chainManager%41FA7915038B.role

      //## Association: XSFit::MCMC::<unnamed>%4200F4F5035C
      //## begin MarginGrid::paramIDs%4200F4F8038C.role preserve=no  public: Chain::ParamID { -> 1..nVHgN}
      std::vector<Chain::ParamID> m_paramIDs;
      //## end MarginGrid::paramIDs%4200F4F8038C.role

    // Additional Implementation Declarations
      //## begin MarginGrid%41F944FD021B.implementation preserve=yes
      //## end MarginGrid%41F944FD021B.implementation

};

//## begin MarginGrid%41F944FD021B.postscript preserve=yes
//## end MarginGrid%41F944FD021B.postscript

// Class MarginGrid::MarginInfo 

// Class MarginGrid 

//## Get and Set Operations for Associations (inline)

inline const MarginGrid::MarginInfo& MarginGrid::marginInfo () const
{
  //## begin MarginGrid::marginInfo%41FA77460304.get preserve=no
  return m_marginInfo;
  //## end MarginGrid::marginInfo%41FA77460304.get
}

inline const std::vector<Chain::ParamID>& MarginGrid::paramIDs () const
{
  //## begin MarginGrid::paramIDs%4200F4F8038C.get preserve=no
  return m_paramIDs;
  //## end MarginGrid::paramIDs%4200F4F8038C.get
}

//## begin module%41F944090175.epilog preserve=yes
//## end module%41F944090175.epilog


#endif
